package xyz.zhouxy.plusone.constant;

import java.util.regex.Pattern;

public enum Patterns {
    DATE("^\\d{4}-\\d{2}-\\d{2}"),

    PASSWORD("^(?=.*\\d)(?=.*[a-z])(?=.*[A-Z])[\\w\\\\!#$%&'*\\+\\-/=?^`{|}~@\\(\\)\\[\\]\",\\.;':><]{8,32}$"),

    CAPTCHA("^[0-9A-Za-z]{4,6}$"),

    EMAIL("^\\w+([-+.]\\w+)*@[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})*(\\.(?![0-9]+$)[a-zA-Z0-9][-0-9A-Za-z]{0,62})$"),

    MOBILE_PHONE("^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\\d{8}$"),

    USERNAME("^[\\da-zA-Z_.@\\\\]{4,36}$"),

    NICKNAME("^[\\da-zA-Z_.@\\\\]{4,36}$"),

    ;

    private final String regex;
    private final Pattern pattern;

    Patterns(String regex) {
        this.regex = regex;
        this.pattern = Pattern.compile(regex);
    }

    public String getRegex() {
        return regex;
    }

    public Pattern getPattern() {
        return pattern;
    }
}
